/**************************************************
бɽץ
ver 1.000.000
      K.Uemura  (2005/09/23)

***************************************************/

#include<iostream>
#include<fstream>
#include<stdio.h>
#include<vector>

using namespace std;

#include "Image.h"

#include "EPostScript.h"
#include "write_ps.h"
#include "PointMark.h"
#include "PARAM.h"

double EPS     =1e-9;
double DET_EPS = 1e-9;

PARAM param;

PointType get_PointType(int flag)
{
  if(flag&FLAG_DOT){
	return dot;
  }
  if(flag&FLAG_CIRCLE){
	return circle;
  }
  return dot;
}


/////////////////////////////////////////////////////////////////////////////////////
//бɤ߹
//бɸȤιԤƬ # ꡢ Хե饰ΩäƤϡιԤΤߤоݤȤ롣
//Хե饰ΩäƤʤϡ# ̵뤹
// 
// fn          бǡե 
//             "(б1uɸ, б1vɸ)--(б2uɸ, б2vɸ)"
//             ηǵҤƤ롣
//crsp1 crsp2  бǼ crsp11б
//flag         Хե饰    0 ȹԤΤ    1 ȹԤΤФ
//
//        бο 
int read_correspondence_pair(char *fn, vector<PointMark> &crsp1, vector<PointMark> &crsp2)
{
  PointMark pt1,pt2;
  ifstream fin(fn);
  
  char *linebuf;
  linebuf = new char[1024];
  if(!linebuf){
	cerr <<"can't get memory. in \"read_correspondence_pair func\""
		<<endl;
	exit(1);
  }
  
  while(!fin.eof()){
	char *buf = linebuf ;
	fin.getline(linebuf,1024);
	bool mark = false;
	//ޡ󥰥ե饰ΩäƤơĥޡ󥰤Ƥʤϡħ˥ޡ󥰤򤷤ʤ
	if(buf[0] == '#'){
// 	  printf("%x\n",FLAG_MARK);	  
 	  if(param.flag & FLAG_MARK)
		mark = true;
 	  else mark = false;
	  buf = linebuf + 1;
	}
	
	pt1.set_mark(mark); pt2.set_mark(mark);
	double u1,v1,u2,v2;
	if(sscanf(buf,"(%lf,%lf)--(%lf,%lf)",&u1,&v1,&u2,&v2) != 4)
	  break;
	pt1.set((int)u1,(int)v1); pt2.set((int)u2,(int)v2);
	crsp1.push_back(pt1);	crsp2.push_back(pt2);
  }	
  delete [] linebuf;
  return (int)crsp1.size();
}

//б˽񤭹ߡEPSȤƽϤ롣
void matching_data_output_to_image(char *img_fn,char *output_fn, vector<PointMark> &crsp_list,
								     PointType ptype, int &width, int &height, const Color &col)
{
  CImage cim(img_fn);
  EPostScript eps(output_fn, cim.xl(), cim.yl()); 
  write_frame(eps,  cim.xl(), cim.yl() );
  
  write_ps(eps, crsp_list, cim, param.jpg_quality,  ptype, param.figure_size, param.linewidth, col);
  
  if(param.flag & FLAG_NUMBER)
	numbering(eps, crsp_list,  param.number_scale, param.offset_u, param.offset_v,WHITE_C,col);
  
  width = cim.xl();
  height = cim.yl();
  eps.close();
}


int main(int argc, char *argv[])
{     
  param.analysis_option(argc, argv);
  
  vector<PointMark> crsp_list1, crsp_list2;
  int width = param.width;
  int height = param.height;
		
  PointType ptype;
  ptype = get_PointType(param.flag);

  read_correspondence_pair(param.match_fn,crsp_list1, crsp_list2);   //бɤ߹
  
  if(param.img_fn1 != 0){
	matching_data_output_to_image(param.img_fn1, param.view_name1, crsp_list1,
								  ptype, width, height, param.col);
  }
  
  if(param.img_fn2 != 0){
	matching_data_output_to_image(param.img_fn2, param.view_name2, crsp_list2,
								  ptype, width, height,param.col);	
  }  

  EPostScript flow_eps(param.flow_name, width, height);  
  write_frame(flow_eps, width,     height    );
 
  //бեȤEPS˽Ϥ롣
  write_flow(flow_eps,crsp_list1,crsp_list2,
			param.figure_size, param.linewidth, param.col);
  
  //ֹդ
  if(param.flag & FLAG_NUMBER){
// 	Color NONE_C ={-1,-1,-1};
	numbering(flow_eps,crsp_list1,
			  param.number_scale, param.offset_u, param.offset_v,WHITE_C,param.col);
  }
  flow_eps.close();
  return 0;
}
