/************************************************
 EPS.cc   Ver 1.0
EPSδ  EPSؤȽ񤭹 ޷ν񤭹̿
EPostScript()   : 󥹥ȥ饯 EPSءإåȥץ񤭹
~EPostScript()  : ǥȥ饯close()ؿ֡
close()         : EPS եå񤭹
print_img()     : EPSػꤷ(PPM)JPGǽ񤭹

plot_dot()      : EPSػꤷΡ񤭹
plot_circle()   : EPSػꤷȴߤ񤭹
plot_number()   : EPSػꤷֹ񤭹
plot_line()     : EPSػꤷľ񤭹
             created by K.Uemura (2005/09/22) 
*************************************************/

#include <iostream>
#include <fstream>
#include <iomanip>

using std::ofstream;
using std::cerr;
using std::endl;
using std::setprecision;

#include "EPostScript.h"
#include "JpegUtils.h"

//  void write_jpeg_operator(ofstream &fstr, int width, int height, ImgType t)
//    ǽ   :  Postscript  jpeg ᡼ڥ졼򵭽Ҥ
//       :  ϥȥ꡼(fstr), (width, height)
//           :  Υ color/gray
//     :  ʤ
void
write_jpeg_operator(ofstream &fstr, int width, int height, ImgType type)
{
  fstr << "/languagelevel where {pop languagelevel 2 lt}{true} ifelse {" << endl;
  fstr << "  (JPEG file needs PostScript Level 2!" << endl;
  fstr << ") dup print flush" << endl;
  fstr << "  /Helvetica findfont 20 scalefont setfont 100 100 moveto show showpage stop" << endl;
  fstr << "} if" << endl;
  fstr << "save" << endl;
  fstr << "/RawData currentfile /ASCII85Decode filter def" << endl;
  fstr << "/Data RawData << >> /DCTDecode filter def" << endl;
  fstr << "0 0 translate" << endl;
  fstr << width << " " << height << " scale" << endl;

  if (type == color)
	fstr << "/DeviceRGB setcolorspace" << endl;
  else
	fstr << "/DeviceGray setcolorspace" << endl;

  fstr << "{ << /ImageType 1" << endl;
  fstr << "     /Width " << width << endl;
  fstr << "     /Height " << height << endl;
  fstr << "     /ImageMatrix [ " << width << " 0 0 " << -height << " 0 " << height << " ]" << endl;
  fstr << "     /DataSource Data" << endl;
  fstr << "     /BitsPerComponent 8" << endl;

  if (type == color)
	fstr << "     /Decode [0 1 0 1 0 1]" << endl;
  else
	fstr << "     /Decode [0 1]" << endl;

  fstr << "  >> image" << endl;
  fstr << "  Data closefile" << endl;
  fstr << "  RawData flushfile" << endl;
  fstr << "  restore" << endl;
  fstr	<< "} exec" << endl;
}




int EPostScript::print_img(const CImage &cim,int quality)
{
  // jpeg ڥ졼
  write_jpeg_operator(_fstr, cim.xl(), cim.yl(), color);
   // jpeg 
  return output_jpegascii(cim, _fstr, quality);
}

int EPostScript::print_img(const Image &im,int quality)
{
  // jpeg ڥ졼
  write_jpeg_operator(_fstr, im.xl(), im.yl(), gray);
   // jpeg 
  return output_mono_jpegascii(im, _fstr, quality);
}


void EPostScript::plot_dot(int u, int v,int scale, const Color &col)
{
  if(!_fstr)return;
  _fstr << "newpath ";
  _fstr << setprecision(3)
	  << col.r / MAXLEVEL <<" "
	  << col.g / MAXLEVEL <<" "
	  << col.b / MAXLEVEL <<" setrgbcolor ";
  _fstr << "1 setlinewidth ";
  _fstr << u << " "<<_height - v << " " <<scale<<" 0 360 arc fill\n";	  
}

void EPostScript::plot_circle(int u, int v, int scale, int linewidth, const Color &col)
{
  if(!_fstr)return ;
  _fstr << "newpath ";
  _fstr << setprecision(3)
	  << col.r / MAXLEVEL << " "
	  << col.g / MAXLEVEL << " "
	  << col.b / MAXLEVEL << " setrgbcolor ";
  _fstr << linewidth << " setlinewidth "
	  << u << " " << _height - v << " " << scale << " 0 360 arc stroke\n";

}
void EPostScript::plot_number(int u, int v, int number, int scale, const Color &col)
{
  if(!_fstr)return ;
  _fstr << "/Helvetica findfont ";

  _fstr << scale <<" scalefont setfont"<<endl;
  _fstr << setprecision(3)
	  << col.r / MAXLEVEL << " "
	  << col.g / MAXLEVEL << " "
	  << col.b / MAXLEVEL << " setrgbcolor ";
  _fstr << u <<" "<< _height - v <<" moveto "<<"("<<number<<") show \n";

}
void EPostScript::plot_line(int start_u, int start_v, int end_u, int end_v,
			    int linewidth, const Color &col)
{
  if(!_fstr)return;
  _fstr << "newpath ";
  _fstr << setprecision(3)
	<< col.r / MAXLEVEL << " "
	<< col.g / MAXLEVEL << " "
	<< col.b / MAXLEVEL << " setrgbcolor ";

  _fstr << linewidth <<" setlinewidth [] 0 setdash ";
  _fstr << start_u<<" "<<_height - start_v<<" moveto "
		<< end_u  <<" "<<_height - end_v<<" lineto stroke \n";;
  
}
  


