/*********************************************************************************
EPS񤭹ߴؿ ե
write_ps()    : ƤħPointTypeǻꤷ޷EPS˽Ϥ
numbering()   : Ƥħˡ(offset_u, offset_v)Υ줿ֹ֤դ
write_flow()  : ƤбФեEPS˽Ϥ
*********************************************************************************/
#include <vector>
#include "PointMark.h"
#include "Image.h"
#include "EPostScript.h"
#include "ImageDefaults.h"
#include "write_ps.h"
#include <math.h>

using namespace std;


int write_frame(EPostScript &eps,int width, int height)
{
  eps.plot_line(0    , 0     , width, 0     , 2, BLACK_C);
  eps.plot_line(width, 0     , width, height, 2, BLACK_C);
  eps.plot_line(width, height, 0    , height, 2, BLACK_C);
  eps.plot_line(0    , height, 0    , 0     , 2, BLACK_C);
  
  return 0;
}

////////////////////////////////////////////////////////////////////////
//PPMħǡŤͤΤEPSȤƽϤؿEPS˽ϤݤˡPPMJPGѴƽϤ롣
//
//eps         ϤEPS
//feature     ħǡ
//cim         PPMǡ
//jpg_quality ѴJPGΥƥ
//
//  1  0
int write_ps(EPostScript &eps, vector<PointMark> &feature,
			 CImage &cim, int jpg_quality,
			 PointType &ptype, int figure_size,int linewidth,
			 const Color &col)
{  
  int num = (int)feature.size();
  eps.print_img(cim,jpg_quality);
  if(ptype == dot){
	for(int i=0; i<num; i++){
	  eps.plot_dot(feature[i].get_u(),feature[i].get_v(),
				   figure_size+2,WHITE_C);
	  if(!feature[i].is_mark()){
		eps.plot_dot(feature[i].get_u(),feature[i].get_v(),
				figure_size, col);
	  }
	  else if(feature[i].is_mark()){
		eps.plot_dot(feature[i].get_u(),feature[i].get_v(),
					 figure_size,RED_C);	  
	  }
	}  
  }
  else if(ptype == circle){
	for(int i=0; i<num; i++){
	  eps.plot_circle(feature[i].get_u(),feature[i].get_v(),
					  figure_size,linewidth+1, WHITE_C);
	  if(!feature[i].is_mark() ){
		eps.plot_circle(feature[i].get_u(),feature[i].get_v(),
				figure_size,linewidth, col);
	  }else if(feature[i].is_mark() ){
		eps.plot_circle(feature[i].get_u(),feature[i].get_v(),
						figure_size,linewidth, RED_C);
	  
	  }
	}    
  }
  
  return 1;
}

//ħɸ˥եå(u,v)äɸˡbackɤĤ֤+ξֹɽ롣
void numbering(EPostScript &eps, vector<PointMark> &feature, int scale, int offset_u, int offset_v,
	       const Color &back,const Color &col)
{
  int num =(int)feature.size();
  int beta = (scale -3)/2 + 1;
  for(int i=0; i<num; i++){
	int alpha = (int)log10(i+1.0) * (scale)/3 + 3;  //ɤĤֹ֤碌

	//ֹθطʤˡ
	// 	if(back.r != -1){  //NONE_C ѤϸˡϤʤ
	eps.plot_dot(feature[i].get_u() + offset_u,
				 feature[i].get_v() - offset_v,
				 scale+1, back);
	// 	}


	//ֹ	
	if(!feature[i].is_mark()){
	  eps.plot_number(feature[i].get_u() - alpha + offset_u,
					  feature[i].get_v() + beta - offset_v,
					  i+1,	scale+2, col);
	}else 	if(feature[i].is_mark()){
	  eps.plot_number(feature[i].get_u() - alpha + offset_u,
					  feature[i].get_v() + beta - offset_v,
					  i+1,	scale+2, RED_C);
	}

  }
}


//ץƥեEPS˽Ϥ롣 
//
// flow         EPS
// crsp1,crsp2  бǡ
// figure_scale դ礭
// linewidth    ե
int write_flow( EPostScript &flow,
		vector<PointMark> &crsp1,vector<PointMark> &crsp2,
		int figure_scale, int linewidth,const Color &col)
{
  int num = crsp1.size();
  if(num != (int)crsp2.size() ){
    cerr << "no match number of crsp1 and number of crsp2 !!"<<endl;
    exit(1);
  }
  for(int i=0; i<num; i++){
	if(!crsp1[i].is_mark()){
	//1бΤۤˡɽ
	  flow.plot_dot(crsp1[i].get_u(),crsp1[i].get_v(),
					figure_scale,col);

	  //ץƥե 
	  flow.plot_line(crsp1[i].get_u(),crsp1[i].get_v(),
					crsp2[i].get_u(),crsp2[i].get_v(),
					linewidth,  col);
	}else if(crsp1[i].is_mark()){
	  flow.plot_dot(crsp1[i].get_u(),crsp1[i].get_v(),
					figure_scale,RED_C);
	  flow.plot_line(crsp1[i].get_u(),crsp1[i].get_v(),
					 crsp2[i].get_u(),crsp2[i].get_v(),
					 linewidth,  RED_C);
	}
  }
  return 1;
}

